<?php
/*
 * Created on 10.12.2006
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */
 class page {
	var $title = "";
	var $site = "";
	var $id = 0;
	var $parent_id = 0;
	var $childs = array();
	
	// adds a child to this node
	function add_child($page) {
		$this->childs[] = $page;
	}
	
	// tries to add a page to the correct parent_id, if parent_id is not found returns false, else true
	function add_page($page) {
		// this node is the parent, so just add it to our childs
		if($this->id == $page->parent_id) {
			$this->childs[] = $page;
			return true;
		// this nod is NOT the parent, so try our childs if they are
		} else {
			for($i = 0; $i < sizeof($this->childs); $i++) {
				if($this->childs[$i]->add_page($page)) {
					return true;
				}
			}
			// neither this node nor our childs are the parent -> we can't add this node
			return false;
		}
	}
	
	// print the strucutre of this nodes childs
	function get_structure($depth = "0") {
		$struct = "";
		if($depth == 0) {
			$struct .= "Site: <b><a href=config/list.php?site=".$this->site.">".$this->site."</a></b><hr>\n";
		}
		$struct .= "<a href=\"pages/edit.php?id=".$this->id."\">".$this->title."</a> [<a href=\"pages/new.php?parent_id=".$this->id."&site=".$this->site."\">+</a>] [<a href=\"pages/show.php?id=".$this->id."&site=".$this->site."\">P</a>]<br>\n";
		for($i = 0; $i < sizeof($this->childs); $i++) {
			for($j = 0; $j < $depth+1; $j++) {
				$struct .= "&nbsp;";
			}
			$struct .= "&nbsp;".$this->childs[$i]->get_structure($depth+1)."\n";
		}
		return $struct;
	}
	
	function get_navigation($depth = "0") {
		$struct = "";
		if($depth == 0) {
			$struct .= "<ul id=\"navi\">\n<li>Startseite: <b><a href=index.html>".$this->site."</a></b></li>\n";
		} else {
			$struct .= "<li><a href=\"".$this->id.".html\">".$this->title."</a></li>\n";
		}
		for($i = 0; $i < sizeof($this->childs); $i++) {
			for($j = 0; $j < $depth+1; $j++) {
				$struct .= "&nbsp;";
			}
			$struct .= "&nbsp;".$this->childs[$i]->get_navigation($depth+1)."\n";
		}
		if($depth == 0) {
			return $struct."</ul>\n";
		} else {
			return $struct;
		}	
	}
	
	function get_sitemap($baseurl) {
		$sitemap = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		$sitemap .= "<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n";
		$entry = "<url>\n";
		if($this->parent_id < 0) {
			$entry .= "<loc>".$baseurl."/index.html</loc>\n";
		} else {
			$entry .= "<loc>".$baseurl."/".$this->id.".html</loc>\n";
		}
		$entry .= "<lastmod>".date("Y-m-d")."</lastmod>\n";
		$entry .= "<changefreq>weekly</changefreq>\n";
		$entry .= "<priority>0.5</priority>\n";
		$entry .= "</url>\n";
		$sitemap .= $entry;
		for($i = 0; $i < sizeof($this->childs); $i++) {
			$sitemap .= $this->childs[$i]->get_sitemap_entry($baseurl);
		}
		$sitemap .= "</urlset>\n";
		//echo("Sitemap: " . htmlentities($sitemap));
		return $sitemap;
	}
	
	function get_sitemap_entry($baseurl) {
		$entry = "<url>\n";
		$entry .= "<loc>".$baseurl."/".$this->id.".html</loc>\n";
		$entry .= "<lastmod>".date("Y-m-d")."</lastmod>\n";
		$entry .= "<changefreq>weekly</changefreq>\n";
		$entry .= "<priority>0.5</priority>\n";
		$entry .= "</url>\n";
		for($i = 0; $i < sizeof($this->childs); $i++) {
			$entry .= $this->childs[$i]->get_sitemap_entry($baseurl);
		}
		//echo("Entry: ".htmlentities($entry));
		return $entry;
	}
	
	function write_sitemap_to_file($baseurl, $output_dir) {
		//echo("Writing Sitemap to " + $output_dir);
		$filename = $output_dir."/sitemap.xml";
		$content = $this->get_sitemap($baseurl);
		
		//echo("Filename: " + $filename);
		
		// Sichergehen, dass die Datei existiert und beschreibbar ist
		if (!file_exists($filename) || is_writable($filename)) {

	   // Wir öffnen $filename im "Anhänge" - Modus.
	   // 	Der Dateizeiger befindet sich am Ende der Datei, und
	   // 	dort wird $somecontent später mit fwrite() geschrieben.
   		if (!$handle = fopen($filename, "w")) {
         	print "Kann die Datei $filename nicht öffnen<br>\n";
         	exit;
   		}

	   // Schreibe $somecontent in die geöffnete Datei.
   		if (!fwrite($handle, $content)) {
       		print "Kann in die Datei $filename nicht schreiben<br>\n";
       		exit;
   		}

   		//print "Fertig, in Datei $filename wurde ".htmlentities($content)." geschrieben<br>\n";
   		//print "Fertig, in Datei $filename wurde geschrieben<br>\n";

	   fclose($handle);

		} else {
   			print "Die Datei $filename ist nicht schreibbar<br>\n";
		}
	}
	
	function write_to_file($output_dir, $navigation) {
		global $dba;
		if($this->parent_id < 0) {
			$filename = $output_dir."/index.html";
		} else {
			$filename = $output_dir."/".$this->id.".html";
		}
		$content = get_config_value_cms('header', $this->site);
		$content = str_replace("DEBMIN_CMS_TAG_TITLE", $this->title, $content);
		
		$content = str_replace("DEBMIN_CMS_TAG_NAVIGATION", $navigation, $content);
		
		$query = "SELECT text FROM cms_pages WHERE id='".$this->id."' LIMIT 1";
		$row = $dba->query_first($query);
		
		$content .= $row[0];
		
		$content .= get_config_value_cms('footer', $this->site);
		
		// Sichergehen, dass die Datei existiert und beschreibbar ist
		if (!file_exists($filename) || is_writable($filename)) {

	   // Wir öffnen $filename im "Anhänge" - Modus.
	   // 	Der Dateizeiger befindet sich am Ende der Datei, und
	   // 	dort wird $somecontent später mit fwrite() geschrieben.
   		if (!$handle = fopen($filename, "w")) {
         	print "Kann die Datei $filename nicht öffnen<br>\n";
         	exit;
   		}

	   // Schreibe $somecontent in die geöffnete Datei.
   		if (!fwrite($handle, $content)) {
       		print "Kann in die Datei $filename nicht schreiben<br>\n";
       		exit;
   		}

   		//print "Fertig, in Datei $filename wurde ".htmlentities($content)." geschrieben<br>\n";
   		//print "Fertig, in Datei $filename wurde geschrieben<br>\n";

	   fclose($handle);

		} else {
   			print "Die Datei $filename ist nicht schreibbar<br>\n";
		}
		for($i = 0; $i < sizeof($this->childs); $i++) {
			$this->childs[$i]->write_to_file($output_dir, $navigation);
		}
	}
}
?>
