<?php
include_once("../lib/_class.dba.inc.php");
include_once("../config/_conf.dba.inc.php");
include_once("../lib/_static.session.inc.php");
include_once("lib/_static.cms.inc.php");
validate_session();

function write_string_to_file($content, $filename) {
	// write the string to the file
	// Sichergehen, dass die Datei nicht existiert oder beschreibbar ist
	if (!file_exists($filename) || is_writable($filename)) {
		
		if(!is_dir(dirname($filename))) {
			mkdir(dirname($filename));
		}
		
		if (!$handle = fopen($filename, "w")) {
			print "Kann die Datei $filename nicht öffnen<br>\n";
			exit;
		}

		// Schreibe $somecontent in die geöffnete Datei.
		if (!fwrite($handle, $content)) {
			print "Kann in die Datei $filename nicht schreiben<br>\n";
			exit;
		}

		//print "Fertig, in Datei $filename wurde ".htmlentities($content)." geschrieben<br>\n";
		//print "Fertig, in Datei $filename wurde geschrieben<br>\n";

		fclose($handle);

	} else {
		print "Die Datei $filename ist nicht schreibbar<br>\n";
	}
}

require_once("templates.php");

$query = "SELECT * FROM devel_cms_projects ORDER BY title DESC";
$results = $dba->query($query);

$sitemap = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.google.com/schemas/sitemap/0.84\">\n";
$base_url = "http://developer.gauner.org/"; // this should be avail in the interface
//$base_dir = "/home/www/developer.gauner.org/htdocs/";
$base_dir = "/home/tex/projects/eclipse/debminphp/htdocs/html/";
$base_dir = get_config_value_global("base_dir");
$base_url = get_config_value_global("base_url");
$main_page = $mph;

while($row = $dba->fetch_array($results)) {
	$current_page = "";
	$changelog = "";
	// add the appropriate sitemap entry
	$sitemap .= "<url>\n<loc>".$base_url.$row[title]."</loc>\n";
	$sitemap .= "<lastmod>".date("Y-m-d")."</lastmod>\n";
	$sitemap .= "<changefreq>weekly</changefreq>\n"; // detect this from the "news" section
	$sitemap .= "<priority>0.5</priority>\n"; // this should be avil. in the interface
	$sitemap .= "</url>\n";
	// add the sub-page
	$tmp_str = str_replace("ABSTRACT_PLAIN", htmlspecialchars($row[abstract]), $ch);
	$tmp_str = str_replace("ABSTRACT", $row[abstract], $tmp_str);
	$tmp_str = str_replace("TITLE", $row[title], $tmp_str);
	$current_page = $tmp_str; // add the per-entry-page-header
	$tmp_str = "";
	$current_page .= "<div id=\"about\">\n";
	$current_page .= "<h2><a name=\"about\">About</a></h2>\n";
	$current_page .= $row[about];
	$current_page .= "</div>\n";
	$current_page .= "<div id=\"news\">\n";
	$current_page .= "<h2><a name=\"news\">News</a></h2>\n";
	$i_query = "SELECT * FROM devel_cms_news WHERE project_id=".$row[id]." ORDER BY publish_date";
	//echo("<h3>Query: ".$i_query."</h3>");
	$i_results = $dba->query($i_query);
	while($i_row = $dba->fetch_array($i_results)) {
		$current_page .= date("d/m/Y", $i_row[publish_date])." - ".$i_row[newstext]."<br />\n";
		$changelog .= date("d/m/Y", $i_row[publish_date])." - ".$i_row[newstext]."\n";
	}
	unset($i_row);
	$current_page .= "</div>\n";
	$current_page .= "<div id=\"features\">\n";
	$current_page .= "<h2><a name=\"feature\">Features</a></h2>\n";
	$current_page .= $row[features];
	$current_page .= "</div>\n";
	$current_page .= "<div id=\"background\">\n";
	$current_page .= "<h2><a name=\"background\">Background</a></h2>\n";
	$current_page .= $row[background];
	$current_page .= "</div>\n";
	$current_page .= "<div id=\"todo\">\n";
	$current_page .= "<h2><a name=\"todo\">Todo</a></h2>\n";
	$current_page .= $row[todo];
	$current_page .= "</div>\n";
	$current_page .= "<div id=\"download\">\n";
	$current_page .= "<h2><a name=\"download\">Download</a></h2>\n";
	$i_query = "SELECT * FROM devel_cms_downloads WHERE project_id=".$row[id]." ORDER BY id";
	//echo("<h3>Query: ".$i_query."</h3>");
	$i_results = $dba->query($i_query);
	while($i_row = $dba->fetch_array($i_results)) {
		$current_page .= "<a href=\"".$i_row[url]."\">".$i_row[title]."</a> (md5sum: ".$i_row[md5sum].")<br />\n";
	}
	unset($i_row);
	$current_page .= "</div>\n";
	$current_page .= "<div id=\"documentation\">\n";
	$current_page .= "<h2><a name=\"documentation\">Documenation</a></h2>\n";
	$current_page .= $row[documentation];
	$current_page .= "</div>\n";
	$current_page .= "<h2><a name=\"svn\">Public SVN</a></h2>\n";
	$current_page .= $row[public_svn];
	$current_page .= "</div>\n";
	$current_page .= "<div id=\"screenshots\">\n";
	$current_page .= "<h2><a name=\"screenshots\">Screenshots</a></h2>\n";
	$i_query = "SELECT * FROM devel_cms_screenshots WHERE project_id=".$row[id]." ORDER BY title";
	//echo("<h3>Query: ".$i_query."</h3>");
	$i_results = $dba->query($i_query);
	while($i_row = $dba->fetch_array($i_results)) {
		$current_page .= "<a href=\"".$i_row[url]."\">".$i_row[title]."</a><br />\n";
	}
	unset($i_row);
	$current_page .= "</div>\n";
	$current_page .= "<div id=\"contact\">\n";
	$current_page .= "<h2><a name=\"contact\">Contact</a></h2>\n";
	$current_page .= $row[contact];
	$current_page .= "</div>\n";
	$current_page .= $cf; // add the per-entry-page-footer
	// add the portion of the main page
	$main_page .= "<tr>\n";
	$main_page .= "<td colspan=\"5\" bgcolor=\"101010\">\n";
	$main_page .= "<font size=\"2\" face=\"Arial\" color=\"white\"><a href=\"".$row[path]."\" target=\"_self\"><b>".$row[title]."</b></a>\n";
	$main_page .= "</font>\n";
	$main_page .= "</td>\n";
	$main_page .= "</tr>\n";
	$main_page .= "<tr>\n";
	$main_page .= "<td>&nbsp;</td>\n";
	$main_page .= "<td><font size=\"2\" face=\"Arial\" color=\"white\">\n";
	$main_page .= $row[abstract]."\n";
	$main_page .= "</font>\n";
	$main_page .= "</td>\n";
	$main_page .= "<td bgcolor=\"white\" align=\"center\">\n";
	$main_page .= "<a href=\"".$row[path]."/\" target=\"_self\"><img src=\"images/url_homepage.gif\" border=\"0\" alt=\"".$row[title]." Homepage\"></a>\n";
	$main_page .= "</td>\n";
	$main_page .= "<td bgcolor=\"white\" align=\"center\">\n";
	$i_query = "SELECT * FROM devel_cms_downloads WHERE project_id=".$row[id]." ORDER BY updated_at LIMIT 1";
	$i_row = $dba->query_first($i_query);
	$main_page .= "<a href=\"".$i_row[url]."\"><img src=\"images/url_tgz.gif\" border=\"0\" alt=\"Download\"></a>\n";
	$main_page .= "</td>\n";
	$main_page .= "<td bgcolor=\"white\" align=\"center\">\n";
	$main_page .= "<a href=\"".$row[path]."/CHANGELOG\"><img src=\"images/changelog.gif\" border=\"0\" alt=\"Changelog\"></a>\n";
	$main_page .= "</td>\n";
	$main_page .= "</tr>\n";
	write_string_to_file($current_page, $base_dir.$row[path]."/index.html");
	write_string_to_file($changelog, $base_dir.$row[path]."/CHANGELOG");
	//echo("<h3>".$changelog."</h3>");
}
$sitemap .= "</urlset>\n";
write_string_to_file($sitemap, $base_dir."/sitemap.xml");
$main_page .= $mpf;
write_string_to_file($main_page, $base_dir."/index.html");

header("Location: ".get_config_value('url_protocol')."://" . $_SERVER['HTTP_HOST'] . rtrim(dirname($_SERVER['PHP_SELF']), '/\\') . "/projects/" . "list.php");
?>