<?php
/*
 * Created on 11.12.2006
 *
 * This class incorporates the ispproxy.net Web-API.
 * It encapsulates a request to the api.
 * 
 */

class ispproxy_request {

var $lines = array();
var $results = array();
var $code = "";
var $description = "";
var $base_url = "";
var $auth = "";
var $command = "";
var $parameter = "";
var $request_url = "";
var $verbose = true;

function init($command) {
	//assemble the url
	$this->base_url = "https://81.3.51.114/api/call.cgi?s_entity=dasd";
	$user = get_config_value('ispproxy_username');
	$pass = get_config_value('ispproxy_password');
	$this->auth = "&s_login=".$user."&s_pw=".$pass;
	$this->command = $command;
	$this->request_url = $this->base_url.$this->auth."&command=".$this->command;
}

// each parameter is in the form parameter=value
// parameter has to be a string array
function execute($parameter = array()) {
	// build the request
	for($i = 0; $i < sizeof($parameter); $i++) {
		$this->parameter .= "&".$parameter[$i];
	}
	$this->request_url .= $this->parameter;
	
	$buffer = "Response String";
	// read the response
	// TODO - Disabled
	//$fp = fopen($this->request_url, "r");
	//$buffer = fread($fp, 1024);
	//fclose($fp);
	

	// parse the response
	//$tok = strtok($buffer, "\n");
	//if($tok != "[RESPONSE]") {
	//	echo("Error - Inavlid Response! Quitting.<br>\n");
	//	print_r($buffer);
		//exit();
	//}
	// put the whole response, line-by-line into an array
	//while ($tok !== false) {
	//	$this->lines[] = $tok;
	//	$tok = strtok("\n");
	//}
	
	//$this->lines = file($this->request_url);
	
	if($fp = @fopen($this->request_url, "r")) {
	  while (!@feof($fp)) {
   		$this->lines[] = @fgets($fp, 4096);
	  }
	} else {
		if($this->verbose) {
	      echo("<h1>FATAL-Error. Can't reach API-Server!</h1>\n");
	      echo("<h3>Please contact your system-administrator and/or check your internet connection.</h3>\n");
		}
	    return false;
	}
	@fclose($fp);

	// actually parse the response line-by-line
	for($i = 0; $i < sizeof($this->lines); $i++) {
		if(strtoupper(substr($this->lines[$i], 0, 4)) == strtoupper("code")) {
			//echo("Code: ".$this->lines[$i]."<br>\n");
			$tok = strtok($this->lines[$i], "=");
			$this->code = trim(strtok("="));
		} else 	if(substr($this->lines[$i], 0, 11) == "description") {
			$this->description = substr($this->lines[$i], 14, strlen($this->lines[$i]));
		} else {
			//echo($this->lines[$i]."<br>\n");
		}
	}
	
	if($this->code == 200) {
		// parse the result
		for($i = 0; $i < sizeof($this->lines); $i++) {
			// PROPERTY[DOMAINCREATEDDATE][0]=2006-05-09 17:22:37
			$line = substr($this->lines[$i], 9);
			// DOMAINCREATEDDATE][0]=2006-05-09 17:22:37
			$prop_name = strtok($line, "]");
			// DOMAINCREATEDDATE
			$prop_num = strtok("]");
			// [0
			$prop_num = substr($prop_num, 1);
			// 0
			$prop_value = strtok("]");
			// =2006-05-09 17:22:37
			$prop_value = trim(substr(trim($prop_value), 1));
			// 2006-05-09 17:22:37
			$this->results[$prop_num][$prop_name] = $prop_value;
		}
	}

	// Debugging output
	//echo("Request: ".$this->request_url."<br>\n");
	//echo("Response-Code: ".$this->code."<br>\n");
	//echo("Response-Description: ".$this->description."<br>\n");
}
}

class ispproxy {
	function check_domain($domain) {
		$req = new ispproxy_request();
		$req->init("CheckDomain");
		$parameter[] = "domain=".urlencode($domain);
		$req->execute($parameter);
		if($req->code == 210) {
			return true;
		} else if($req->code == 211) {
			return false;
		} else {
			//return "Error during Request. Please try again.";
			return false;
		}
	}
	
	function check_domains($domains) {
		$command = "CheckDomains";
		// a max. of 31 domains is allowed by the API
		for($i = 0; ($i < sizeof($domains) && $i < 32); $i++) {
			if(strlen($domains[$i]) > 2) {
				$parameter[] = "domain".$i."=".urlencode($domains[$i]);
			}
		}
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		$response = array();
		$j = 0;
		for($i = 4; $i < sizeof($request->lines)-7; $i=$i+2) {
			$tok = strtok($request->lines[$i], "=");
			$tok = strtok("=");
			$substr = substr($tok, 1, 3);
			if($substr == "210") {
				$response[] = $domains[$j]." is available";
			} else if ($substr == "211") {
				$response[] = $domains[$j]." is NOT available";
			} else {
				$response[] = $domains[$j].": Error during Request. Please try again.";
			}
			$j++;
		}
		return $response;
	}
	
	// this function return a tld-selector
	function get_tldomain_selector($name) {
		$domains = $this->get_avail_domains();
		$html = "<select name=".$name." size=\"1\">\n";
		for($i = 0; $i < sizeof($domains); $i++) {
			$html .= "<option value=\"".$domains[$i]."\">".$domains[$i]."</option>\n";
		}
		$html .= "</select>";
		return $html;
	}
	
	// this function returns a array of all avail. tlds and their prices
	function get_domain_prices() {
			$command = "StatusUser";
			$request = new ispproxy_request();
			$request->init($command);
			$request->execute();
			$regexp_annual = "@PRICE_CLASS_DOMAIN_.*_ANNUAL@";
			$regexp_setup = "@PRICE_CLASS_DOMAIN_.*_SETUP@";
			$regexp_currency = "@PRICE_CLASS_DOMAIN_.*_CURRENCY@";
			//$prices[tld][0] = "TLD";
			//$prices[tld][1] = "ANNUAL";
			//$prices[tld][2] = "SETUP";
			//$prices[tld][3] = "CURRENCY";
			for($i = 0; $i < sizeof($request->lines); $i++) {
				if(preg_match($regexp_annual, $request->lines[$i], $match)) {
					$tld = substr($match[0], 19, strlen($match[0])-(7+19));
					$tok = strtok($request->lines[$i+1], "=");
					$tok = strtok("=");
					$prices[$tld][1] = substr($tok, 1);
					$prices[$tld][0] = $tld;
				} else if(preg_match($regexp_setup, $request->lines[$i], $match)) {
					$tld = substr($match[0], 19, strlen($match[0])-(6+19));
					$tok = strtok($request->lines[$i+1], "=");
					$tok = strtok("=");
					$prices[$tld][2] = substr($tok, 1);
				} else if(preg_match($regexp_currency, $request->lines[$i], $match)) {
					$tld = substr($match[0], 19, strlen($match[0])-(9+19));
					$tok = strtok($request->lines[$i+1], "=");
					$tok = strtok("=");
					$prices[$tld][3] = substr($tok, 1);
				}
			}
			return $prices;
	}
	
	// this functions gets the annual and setup fee and the currency for a single domain
	function get_domain_price($domain) {
		$regexp = "@[.]+[a-zA-Z]+@"; // extrahiert die domain
		if(!preg_match($regexp, $domain, $treffer)) { // invalid url, return to main-page
			return "Keine gültige Domain!";
		} else {
			$price_annual = 1000;
			$price_setup = 1000;
			$price_currency = 1000;
			$tld = strtoupper(substr($treffer[0], 1));
			$domainannual = "PRICE_CLASS_DOMAIN_".$tld."_ANNUAL";
			$domainsetup = "PRICE_CLASS_DOMAIN_".$tld."_SETUP";
			$domaincurrency = "PRICE_CLASS_DOMAIN_".$tld."_CURRENCY";
			$command = "StatusUser";
			$request = new ispproxy_request();
			$request->init($command);
			$request->execute();
			for($i = 0; $i < sizeof($request->lines); $i++) {
				if(stristr($request->lines[$i], $domainannual)) {
					$tok = strtok($request->lines[$i+1], "=");
					$tok = strtok("=");
					$price_annual = substr($tok, 1);
				} else if(stristr($request->lines[$i], $domainsetup)) {
					$tok = strtok($request->lines[$i+1], "=");
					$tok = strtok("=");
					$price_setup = substr($tok, 1);
				} else if(stristr($request->lines[$i], $domaincurrency)) {
					$tok = strtok($request->lines[$i+1], "=");
					$tok = strtok("=");
					$price_currency = substr($tok, 1);
				}
			}
			$ret[dclass] = $tld;
			$ret[annual] = $price_annual;
			$ret[setup] = $price_setup;
			$ret[currency] = $price_currency;
			return $ret;
		}
	}
	
	function get_domain_list() {
		$command = "QueryDomainList";
		$parameter[] = "wide=1";
		$parameter[] = "orderby=DOMAIN";
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		if($request->code == 200) {
			$results = array();
			// parse the result
			for($i = 0; $i < sizeof($request->lines); $i++) {
				// PROPERTY[DOMAINCREATEDDATE][0]=2006-05-09 17:22:37
				$line = substr($request->lines[$i], 9);
				// DOMAINCREATEDDATE][0]=2006-05-09 17:22:37
				$prop_name = strtok($line, "]");
				// DOMAINCREATEDDATE
				$prop_num = strtok("]");
				// [0
				$prop_num = substr($prop_num, 1);
				// 0
				$prop_value = strtok("]");
				// =2006-05-09 17:22:37
				$prop_value = substr(trim($prop_value), 1);
				// 2006-05-09 17:22:37
				$results[$prop_num][$prop_name] = $prop_value;
			}
		}
		return $results;
	}
	
	function get_handle($handle) {
		$command = "StatusContact";
		$parameter[] = "contact=".urlencode($handle);
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		return $request->results;
	}
	
	function get_handles() {
		$command = "QueryContactList";
		$parameter[] = "userdepth=ALL";
		$parameter[] = "wide=1";
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		return $request->results;
	}
	
	function get_handle_selector($name, $selected = "") {
		$html = "<select name=\"".$name."\" size=\"1\">\n";
		$handles = $this->get_handles();
		for($i = 0; $i < sizeof($handles); $i++) {
			if($handles[$i] == $selected) {
				$html .= "<option selected value=\"".$handles[$i][CONTACT]."\">".$handles[$i][CONTACT]."</option>\n";
			} else {
				$html .= "<option value=\"".$handles[$i][CONTACT]."\">".$handles[$i][CONTACT]."</option>\n";
			}
		}
		$html .= "</select>\n";
		return $html;
	}
	
	function get_incoming_transfers() {
		$command = "QueryTransferList";
		$parameter[] = "userdepth=ALL";
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		return $request->results;
	}
	
	function get_outgoing_transfers() {
		$command = "QueryForeignTransferList";
		$parameter[] = "userdepth=ALL";
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		return $request->results;
	}
	
	// checks if this domain ins handled by ispproxy
	function is_ispproxy_dnszone($zone) {
		$command = "StatusDNSZone";
		$parameter[] = "dnszone=".$zone;
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		if($request->code == 200) {
			return true;
		} else {
			return false;
		}
	}
	
	function create_handle($contact_data, $new = "0") {
		$command = "AddContact";
		$parameter[] = "organization=".urlencode($contact_data[company]);
		$parameter[] = "firstname=".urlencode($contact_data[firstname]);
		$parameter[] = "lastname=".urlencode($contact_data[lastname]);
		$parameter[] = "street=".urlencode($contact_data[street]);
		$parameter[] = "city=".urlencode($contact_data[city]);
		$parameter[] = "zip=".urlencode($contact_data[zip]);
		$parameter[] = "country=".urlencode($contact_data[country]); // e.g. DE, EN, ... see ISO 3166
		$parameter[] = "phone=".urlencode($contact_data[phone]);
		$parameter[] = "fax=".urlencode($contact_data[fax]);
		$parameter[] = "email=".urlencode($contact_data[email]);
		$parameter[] = "new=".$new;
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		if($request->code == "200") {
			return substr($request->lines[3], 23);
		} else {
			return "ERROR. The Command failed!";
		}
	}
	
	function delete_handle($handle) {
		$command = "DeleteContact";
		$request = new ispproxy_request();
		$request->init($command);
		$parameter[] = "contact=".urlencode($handle);
		$request->execute($parameter);
		if($request->code == "200") {
			return true;
		} else {
			return false;
		}
	}
	
	// you have to crate one or more handles AND the DNS-Zone before registering!
	function register_domain($domain, $ownerc, $adminc, $techc, $billingc) {
		$command = "AddDomain";
		$request = new ispproxy_request();
		$request->init($command);
		$parameter[] = "domain=".urlencode($domain);
		$parameter[] = "period=1Y";
		$parameter[] = "ownercontact0=".$ownerc;
		$parameter[] = "admincontact0=".$adminc;
		$parameter[] = "techcontact0=".$techc;
		$parameter[] = "billingcontact0=".$billingc;
		$parameter[] = "nameserver0=ns1.ispdnsserver.com";
		$parameter[] = "nameserver1=ns2.ispdnsserver.com";
		$parameter[] = "nameserver2=ns3.ispdnsserver.com";
		//$request->execute($parameter);
		if($request->code == "200") {
			return true;
		} else {
			return false;
		}
	}
	
	function delete_domain($domain) {
		$command = "DeleteDomain";
		$request = new ispproxy_request();
		$request->init($command);
		$parameter[] = "domain=".urlencode($domain);
		//$request->execute($parameter);
		if($request->code == "200") {
			return true;
		} else {
			return false;
		}
	}
	
	function modify_domain($domain, $ownerc = "", $adminc = "", $techc = "", $billingc = "", $ns0 = "", $ns1 = "", $ns2 = "", $ns3 = "", $auth = "", $addstatus = "", $delstatus = "") {
		$command = "ModifyDomain";
		$request = new ispproxy_request();
		$request->init($command);
		$parameter[] = "domain=".urlencode($domain);
		if(strlen($ownerc) > 1) {
			$parameter[] = "ownercontact0=".$ownerc;
		}
		if(strlen($adminc) > 1) {
			$parameter[] = "admincontact0=".$adminc;
		}
		if(strlen($techc) > 1) {
			$parameter[] = "techcontact0=".$techc;
		}
		if(strlen($billingc) > 1) {
			$parameter[] = "billingcontact0=".$billingc;
		}
		if(strlen($ns0) > 1) {
			$parameter[] = "nameserver0=".$ns0;
		}
		if(strlen($ns1) > 1) {
			$parameter[] = "nameserver1=".$ns1;
		}
		if(strlen($ns2) > 1) {
			$parameter[] = "nameserver2=".$ns2;
		}
		if(strlen($ns3) > 1) {
			$parameter[] = "nameserver3=".$ns3;
		}
		if(strlen($auth) > 1) {
			$parameter[] = "auth=".$auth;
		}
		if(strlen($addstatus) > 1) {
			$parameter[] = "addstatus0=".$addstatus;
		}
		if(strlen($delstatus) > 1) {
			$parameter[] = "delstatus0=".$delstatus;
		}
		$request->execute($parameter);
		if($request->code == "200") {
			return true;
		} else {
			return false;
		}
	}
	
	function status_domain($domain) {
		$command = "StatusDomain";
		$parameter[] = "domain=".urlencode($domain);
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		return $request->results;
	}
	
	function request_transfer_domain($domain, $auth = "") {
		$command = "TransferDomain";
		$parameter[] = "domain=".urlencode($domain);
		$parameter[] = "auth=".$auth;
		$parameter[] = "action=request";
		//$request->execute($parameter);
		if($request->code == "200") {
			return true;
		} else {
			return false;
		}
	}
	
	// creates a new dns zone
	function dns_create_zone($zone_name, $rrs = array()) {
		$command = "CreateDNSZone";
		$parameter[] = "dnszone=".urlencode($zone_name);
		$parameter[] = "soamname=ns1.ispdnsserver.com.";
		for($i = 0; $i < sizeof($rrs); $i++) {
			$parameter[] = "rr".$i."=".urlencode($rrs[$i]);
		}
		$parameter[] = "rr".$i++."=@ IN NS ns1.ispdnsserver.com.";
		$parameter[] = "rr".$i++."=@ IN NS ns2.ispdnsserver.com.";
		$parameter[] = "rr".$i++."=@ IN NS ns3.ispdnsserver.com.";
		$dcz = new ispproxy_request();
		$dcz->init($command);
		//$dcz->execute($parameter);
		if($dcz->code > 500) {
			return false;
		} else {
			return true;
		}
	}
	
	function dns_delete_zone($zone_name) {
		$command = "DeleteDNSZone";
		$parameter[] = "dnszone=".urlencode($zone_name);
		$dcz = new ispproxy_request();
		$dcz->init($command);
		//$dcz->execute($parameter);
		if($dcz->code > 500) {
			return false;
		} else {
			return true;
		}
	}
	
	function dns_add_rr($zone_name, $rrs = array()) {
		$command = "UpdateDNSZone";
		$parameter[] = "dnszone=".urlencode($zone_name);
		for($i = 0; $i < sizeof($rrs); $i++) {
			$parameter[] = "addrr".$i."=".urlencode($rrs[$i]);
		}
		$dcz = new ispproxy_request();
		$dcz->init($command);
		$dcz->execute($parameter);
		if($dcz->code > 499) {
			return false;
		} else {
			return true;
		}
	}
	
	function dns_delete_rr($zone_name, $rrs = array()) {
		$command = "UpdateDNSZone";
		$parameter[] = "dnszone=".urlencode($zone_name);
		for($i = 0; $i < sizeof($rrs); $i++) {
			$parameter[] = "delrr".$i."=".urlencode($rrs[$i]);
		}
		$dcz = new ispproxy_request();
		$dcz->init($command);
		//$dcz->execute($parameter);
		if($dcz->code > 500) {
			return false;
		} else {
			return true;
		}
	}
	
	// Removes the old rrs and adds the new ones. TODO Test this!
	function dns_update_rr($zone_name, $oldrrs = array(), $newrrs = array()) {
		$command = "UpdateDNSZone";
		$parameter[] = "dnszone=".urlencode($zone_name);
		for($i = 0; $i < sizeof($oldrrs); $i++) {
			$parameter[] = "delrr".$i."=".urlencode($oldrrs[$i]);
		}
		$dcz = new ispproxy_request();
		$dcz->init($command);
		//$dcz->execute($parameter);
		unset($parameter);
		if($dcz->code > 500) {
			return false;
		} else {
			$dcz = new ispproxy_request();
			$dcz->init($command);
			$parameter[] = "dnszone=".$zone_name;
			for($i = 0; $i < sizeof($newrrs); $i++) {
				$parameter[] = "addrr".$i."=".urlencode($newrrs[$i]);
			}
			//$dcz->execute($parameter);
			if($dcz->code > 500) {
				return false;
			} else {
				return true;
			}
		}
	}
	
	function dns_get_zones() {
		$command = "QueryDNSZoneList";
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute();
		return $request->results;
	}
	
	function dns_get_zone($zone_name) {
		$command1 = "StatusDNSZone";
		$parameter[] = "dnszone=".urlencode($zone_name);
		$request1 = new ispproxy_request();
		$request1->init($command1);
		$request1->execute($parameter);
		$command2 = "QueryDNSZoneRRList";
		$request2 = new ispproxy_request();
		$request2->init($command2);
		$request2->execute($parameter);
		$zone = array();
		for($i = 0; $i < sizeof($request1->results); $i++) {
			$zone[] = $request1->results[$i];
		}
		for($i = 0; $i < sizeof($request2->results); $i++) {
			$zone[] = $request2->results[$i];
		}
		return $zone;
	}
	
	function event_get_list() {
		$command = "QueryEventList";
		$parameter[] = "wide=1";
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		return $request->results;
	}
	
	function event_status($event_id) {
		$command = "StatusEvent";
		$parameter[] = "event=".urlencode($event_id);
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute($parameter);
		return $request->results;
	}
	
	function event_delete($event_id) {
		$command = "DeleteEvent";
		$parameter[] = "event=".urlencode($event_id);
		$request = new ispproxy_request();
		$request->init($command);
		#$request->execute($parameter);
		if($dcz->code > 500) {
			return false;
		} else {
			return true;
		}
	}
	
	function accounting_add($subuser, $description, $type, $amount, $payment, $reference = "") {
		$command = "AddAccounting";
		$parameter[] = "subuser=".urlencode($subuser);
		$parameter[] = "description=".urlencode($description);
		$parameter[] = "type=".urlencode($type);
		$parameter[] = "amount=".urlencode($amount);
		$parameter[] = "payment=".urlencode($payment);
		$parameter[] = "reference=".urlencode($reference);
		$request = new ispproxy_request();
		$request->init($command);
		#$request->execute($parameter);
		if($dcz->code > 500) {
			return false;
		} else {
			return true;
		}
	}
	
	function accounting_modify($acct_id, $subuser, $description, $type, $amount, $payment, $reference = "") {
		$command = "ModifyAccounting";
		$parameter[] = "accountingid=".urlencode($acct_id);
		$parameter[] = "subuser=".urlencode($subuser);
		$parameter[] = "description=".urlencode($description);
		$parameter[] = "type=".urlencode($type);
		$parameter[] = "amount=".urlencode($amount);
		$parameter[] = "payment=".urlencode($payment);
		$parameter[] = "reference=".urlencode($reference);
		$request = new ispproxy_request();
		$request->init($command);
		#$request->execute($parameter);
		if($dcz->code > 500) {
			return false;
		} else {
			return true;
		}
	}
	
	function accounting_delete($subuser, $acct_id) {
		$command = "DeleteAccounting";
		$parameter[] = "subuser=".urlencode($subuser);
		$parameter[] = "accountingid=".urlencode($acct_id);
		$request = new ispproxy_request();
		$request->init($command);
		#$request->execute($parameter);
		if($dcz->code > 500) {
			return false;
		} else {
			return true;
		}
	}
	
	function accounting_get_list() {
		$command = "QueryAccountingList";
		$request = new ispproxy_request();
		$request->init($command);
		$request->execute();
		return $request->results;
	}
	
	// this function checks if the remote-api server is reachable
	function is_online() {
		$request = new ispproxy_request();
		$command = "CheckDomain";
		$request->init($command);
		$parameter[] = "domain=test.de";
		return $request->execute($parameter);
	}
	
		// this function returns a array of all avail. tlds
	function get_avail_domains() {
		$domains[] = "de";
		$domains[] = "com";
		$domains[] = "net";
		$domains[] = "org";
		$domains[] = "info";
		$domains[] = "biz";
		$domains[] = "ac";
		$domains[] = "aero";
		$domains[] = "ag";
		$domains[] = "am";
		$domains[] = "at";
		$domains[] = "be";
		$domains[] = "biz.pl";
		$domains[] = "bz";
		$domains[] = "cc";
		$domains[] = "ch";
		$domains[] = "club.tw";
		$domains[] = "cn";
		$domains[] = "co.at";
		$domains[] = "co.in";
		$domains[] = "com.ag";
		$domains[] = "com.cn";
		$domains[] = "com.es";
		$domains[] = "com.pl";
		$domains[] = "com.sc";
		$domains[] = "com.sg";
		$domains[] = "com.tw";
		$domains[] = "com.vc";
		$domains[] = "co.uk";
		$domains[] = "ebiz.tw";
		$domains[] = "es";
		$domains[] = "eu";
		$domains[] = "firm.in";
		$domains[] = "fm";
		$domains[] = "game.tw";
		$domains[] = "gen.in";
		$domains[] = "gs";
		$domains[] = "idv.tw";
		$domains[] = "im";
		$domains[] = "ind.in";
		$domains[] = "info.pl";
		$domains[] = "in";
		$domains[] = "io";
		$domains[] = "it";
		$domains[] = "jobs";
		$domains[] = "jp";
		$domains[] = "la";
		$domains[] = "li";
		$domains[] = "md";
		$domains[] = "me.uk";
		$domains[] = "mn";
		$domains[] = "mobi";
		$domains[] = "ms";
		$domains[] = "name";
		$domains[] = "net.ag";
		$domains[] = "net.cn";
		$domains[] = "net.in";
		$domains[] = "net.pl";
		$domains[] = "net.sc";
		$domains[] = "net.vc";
		$domains[] = "nl";
		$domains[] = "nom.es";
		$domains[] = "nu";
		$domains[] = "or.at";
		$domains[] = "org.ag";
		$domains[] = "org.cn";
		$domains[] = "org.cn";
		$domains[] = "org.in";
		$domains[] = "org.pl";
		$domains[] = "org.sc";
		$domains[] = "org.tw";
		$domains[] = "org.uk";
		$domains[] = "org.vc";
		$domains[] = "pl";
		$domains[] = "ru";
		$domains[] = "sc";
		$domains[] = "se";
		$domains[] = "sg";
		$domains[] = "sh";
		$domains[] = "tc";
		$domains[] = "tk";
		$domains[] = "tm";
		$domains[] = "travel";
		$domains[] = "tv";
		$domains[] = "tw";
		$domains[] = "us";
		$domains[] = "vc";
		$domains[] = "vg";
		$domains[] = "ws";
		return $domains;
	}
}

function get_domain_from_domain($domain) {
	$regexp_tldomain = "@[A-Za-z0-9-]+[.][A-Za-z]+$@";
	preg_match($regexp_tldomain, $domain, $match);
	return $match[0];
}

function get_tld_from_domain($domain) {
	$regexp_tld = "@[.][A-Za-z0-9-]+$@";
	preg_match($regexp_tld, $domain, $match);
	return $match[0];
}

function get_subdomain_from_domain($domain) {
	$dom = get_domain_from_domain($domain);
	return substr($domain, 0, strlen($domain)-strlen($dom));
}
?>
