<?php
// This is the Logger Class
// Author: Dominik Schulz <ds@gauner.org>
// April 2006

class logger {
	var $loglines = array();
	var $max_buffer_len = 128; // how many lines (!) can be bufferd in $this->logline bevore flush() is called
	var $appname = "Logger"; // shall be set on initialisation of this class
	var $show_error = 1;
	var $sink = "txt"; // textfile or sql
	var $log_dest = ""; // is either a filename f�r sink txt or a sql-table for sink sql
	var $sql_dba = ""; // the dba handle for sql logging
	var $text_loghandle = "";
	// DB-Schema:
	// id, host, priority, facility, message, created_at
	// int(32), VARCHAR(255), VARCHAR(9), VARCHAR(255), VARCHAR(255), INT(16)
	// Priorities | Example
	// DEBUG - lowest (db-query, ...)
	// NOTICE - user login
	// WARNING - user login->wrong password
	// ERR - not able to read a file
	// CRIT - not able to write a file
	// ALERT - highest (confirmed security breach oder kernel panic)
	
	function logger($appname, $sink = "txt", $log_dest = "./logger.log", $dba = "") {
		$this->appname = $appname;
		$this->sink = $sink;
		$this->log_dest = $log_dest;
		$this->sql_dba = $dba;
		$this->open();
	}
	
	function open() {
		if($this->sink == "sql") {
			$this->open_sql();
		} else {
			$this->open_txt();
		}
		return true;
	}
	
	function open_txt() {
		if($this->text_loghandle = @fopen($this->log_dest, "a")) {
			return true;
		} else {
			$this->print_error("Kann Logfile nicht schreiben: ".$log_dest);
		}
	}
	
	function open_sql() {
		$priority = "DEBUG";
		$host = $_SERVER["SERVER_NAME"];
		$created_at = time();
		$facility = $this->appname;
		$message = "Starting Logging session.";
		$query = "INSERT INTO ".$this->log_dest." (host, priority, facility, message, created_at) VALUES ('".$host."','".$priority."','".$facility."','".$message."','".$created_at."')";
		$this->sql_dba->query($query);
		return true;
	}
	
	function flush() {
		if($this->sink == "sql") {
			$this->flush_sql();
		} else {
			$this->flush_txt();
		}
		return true;
	}
	
	function flush_txt() {
	// write everything from the buffer to the file and clears out the internal buffer
		for($i = 0; $i < count($this->loglines); $i++) {
			$string = $this->loglines[$i][0].";".$this->loglines[$i][1].";".$this->loglines[$i][2].";".$this->loglines[$i][3].";".$this->loglines[$i][4]."\n";
			if(!@fwrite($this->text_loghandle, $string)) {
				$this->print_error("Konnte folgendes nicht an das Log anh�ngen:\n\n".$string);
			}
		}
		$this->loglines = array(); // reset the buffer
		return true;
	}
	
	function flush_sql() {
		for($i = 0; $i < count($this->loglines); $i++) {
			// id, host, priority, facility, message, created_at
			$query = "INSERT INTO ".$this->log_dest." (host, priority, facility, message, created_at) VALUES ('".$this->loglines[$i][0]."','".$this->loglines[$i][1]."','".$this->loglines[$i][2]."','".$this->loglines[$i][3]."','".$this->loglines[$i][4]."')";
			if(!$this->sql_dba->query($query)) {
				$this->mail_notify("Unrecoverable Database error!","Dear Admin,\nplease investigate this error.\n".$this->appname);
				$this->print_error("Unrecoverable Database error! Giving up.\n");
				return false;
			}
		}
		$this->loglines = array(); // reset the buffer
		return true;
	}
	
	function close() {
		$this->flush();
		if($this->sink == "sql") {
			$this->close_sql();
		} else {
			$this->close_txt();
		}
		return true;
	}
	
	// do flush and the close the file handle
	function close_txt() {
		@fclose($this->text_loghandle);
		return true;
	}
	
	function close_sql() {
		$priority = "DEBUG";
		$host = $_SERVER["SERVER_NAME"];
		$created_at = time();
		$facility = $this->appname;
		$message = "Closing DB connection.";
		$query = "INSERT INTO ".$this->log_dest." (host, priority, facility, message, created_at) VALUES ('".$host."','".$priority."','".$facility."','".$message."','".$created_at."')";
		$this->sql_dba->query($query);
	}
	
	// appends the string to the buffer, prepended by the flag
	function log($message, $prio = "NOTICE", $flush = "no") {
		// if the buffer would become to long after appending the string, flush it first
		if((count($this->loglines)+1) > $this->max_buffer_len) {
			$this->flush();
		}
		$host = $_SERVER["SERVER_NAME"];
		$created_at = time();
		$facility = $this->appname;
		$this->loglines[] = array($host, $prio, $facility, $message, $created_at);
		if($prio != "DEBUG") {
			$this->mail_notify($this->appname." Mail Notify", "Host: ".$host."\nPriority: ".$prio."\nFacility: ".$facility."\nMessage: ".$message."\nTime: ".date("d.m.Y h:i:s", $created_at));
		}
		if($flush == "yes") {
			$this->flush();
		}
		return true;
	}
	
	function mail_notify($subject, $message) {
		// send a notice to the admin, requiers _class.multipartmail.inc.php
		$dest = get_config_value('mail_from');
		$mail = new multipartmail($dest, $dest, $subject);
		$mail->addmessage($message);
		$mail->sendmail();
		return true;
	}
	
	function print_error($msg) {
    		$message = "<table width=\"50%\"><tr><td bgcolor=\"red\">\n";
    		$message .= "Logging error in $this->appname: $msg\n<br>";
    		$message .= "Date: ".date("d.m.Y @ H:i")."\n<br>";
    		$message .= "Script: ".getenv("REQUEST_URI")."\n<br>";
    		$message .= "Referer: ".getenv("HTTP_REFERER")."\n<br><br>";

    		if( $this->show_error) {
    			$message = "$message";
    		} else {
    			$message = "\n<!-- $message -->\n";
    		}
			
		echo("<html><head><title>Logging-Error</title></head><body>\n");
		echo("<font face=\"Verdana\" size=\"2\">");		
		echo($message);
		echo("</font>\n");
		echo("</body></html>");
		exit;
	}

}

?>