<?php
//this is our modules-class
class navigation_items {
	var $items = array();
	var $name = "";
	var $filename = "";
	
	// init the top-level link
	function init($name, $filename) {
		$this->name = $name;
		$this->filename = $filename;
	}
	 // add a nested-link
	function add($name, $filename) {
		$i = sizeof($this->items);
		$this->items[$i][0] = $name;
		$this->items[$i][1] = $filename;
	}
	
	// get item nr. $i
	function get($i) {
		if($i < sizeof($this->items)) {
			return $this->items[$i];
		} else {
			return array("", ""); // if wrong index -> return array of size 0
		}
	}
	
	// generates the html navigation
	function getHTML() {
		$html = "<!-- Module: ".$this->name." -->\n";
		$html .= "<a href=\"".$this->filename."\" target=\"detail\">".$this->name."</a><br />\n";
		$html .= "<span class=\"nav_small\">\n";
		for($i = 0; $i < sizeof($this->items); $i++) {
			$html .= "<a href=\"".$this->items[$i][1]."\" target=\"detail\">".$this->items[$i][0]."</a><br />\n";
		}
		$html .= "</span><br />\n";
		return $html."<!-- EndModule: ".$this->name." -->\n";
	}
	
	// get the number of items
	function size() {
		return sizeof($this->items);
	}
}

class modules {
	//var $database = "";
	//var $link_id  = 0;
	var $modules   = array();
  	var $appname  = "Debmin";
  	
  	// $modules->init(); - the constructor
  	function init() {
		// ??
  	}
	
	// $modules->add("Shortname", "Basedir", "Description")
	// This funtion adds a new module to the module
	// registry.
	function add($name, $description, $category, $nav_items) {
		$i = sizeof($this->modules) + 1; // the next free entry
		$this->modules[$i][0] = $name;
		$this->modules[$i][1] = $description;
		$this->modules[$i][2] = $category;
		$this->modules[$i][3] = $nav_items;
	}
	
	// returns a nice formated HTML-Navigation
	function getHTML($category = "") {
		$html = "";
		if(strlen($category) > 1) {
			for($i = 0; $i <= sizeof($this->modules); $i++) {
				if($this->modules[$i][2] == $category) {
					$html .= $this->modules[$i][3]->getHTML();
				}
			}
		} else if(strlen($category) <= 1) {
			for($i = 0; $i < sizeof($this->modules); $i++) {
				//echo("Modul #".$i.", Name: ".$this->modules[$i][0]."<br />\n");
				if($this->modules[$i][3] != null)
					$html .= $this->modules[$i][3]->getHTML();
			}
		}
		return $html;
	}
	
	function getCategories() {
		$cats = array();
		//echo("<!-- modules->getCategories() - sizeof(modules): ".sizeof($this->modules)."-->\n");
		for($i = 0; $i <= sizeof($this->modules); $i++) {
		// only add this cat if it's not already in our list and is not empty
			//echo("<!-- modules->getCategories() - Considering: ".$this->modules[$i][0].", ".$this->modules[$i][1].", ".$this->modules[$i][2]."-->\n");
			if((strlen(array_search($this->modules[$i][2], $cats)) < 1) && (strlen($this->modules[$i][0]) > 0)) {
				//echo("<!-- modules->getCategories() - Added: ".$this->modules[$i][0].", ".$this->modules[$i][1].", ".$this->modules[$i][2]."-->\n");
				$cats[] = $this->modules[$i][2];
			}
		}
		return $cats;
	}
	
	// generates the html to swtich the navigation section
	function getSectionChangerHTML() {
		$link_prefix = " <a href=\"".get_config_value('url_protocol')."://" . $_SERVER['HTTP_HOST'].rtrim(dirname($_SERVER['PHP_SELF']), '/\\'). "/".rtrim(basename($_SERVER['PHP_SELF']), '/\\')."?page=";
		$html = "<!-- Section Changer -->\n";
		$html .= "<span class=\"nav_tiny\">\n";
		$cats = $this->getCategories();
		for($i = 0; $i < sizeof($cats)-1; $i++) {
			$html .= $link_prefix.$cats[$i]."\" target=\"_self\">".$cats[$i]."</a> |";
		}
		$html .= $link_prefix.$cats[$i]."\" target=\"_self\">".$cats[$i]."</a>\n</span><br />\n";
		return $html."<!-- Section Changer End -->\n";
	}
	
	// @param - the name of a (fiktive) module to check
	// @return true if this module exists and is registered
	function isModule($name) {
		for($i = 0; $i < $this->size(); $i++) {
			if($this->modules[$i][0] == $name) {
				return true;
			}
		}
		return false;
	}
	
	// @return the number of modules in this category or, if category is empty the number of all modules
	function size($category = "") {
		if(sizeof($category) < 1) {
		return sizeof($this->modules);
		} else {
		  $n = 0;
		  for($i = 0; $i < sizeof($this->modules); $i++) {
			if($this->modules[$i][2] == $category) {
				$n++;
			}
		  }
		  return $n;
		}
	}
	
  	// $modules->print_error( $msg); - prints an error
  	function print_error($msg) {

    		$message = "<table width=\"50%\"><tr><td bgcolor=\"red\">\n";
    		$message .= "Database error in $this->appname: $msg\n<br>";
    		$message .= "Date: ".date("d.m.Y @ H:i")."\n<br>";
    		$message .= "Script: ".getenv("REQUEST_URI")."\n<br>";
    		$message .= "Referer: ".getenv("HTTP_REFERER")."\n<br><br>";

    		if( $this->show_error) {
    			$message = "$message";
    		} else {
    			$message = "\n<!-- $message -->\n";
    		}
		echo("<html><head><title>Module-Error</title></head><body>\n");
		echo("<font face=\"Verdana\" size=\"2\">");		
		echo($message);
		echo("</font>\n");
		echo("</body></html>");
		die();
    	}
}
?>
