-- MySQL dump 9.11
--
-- Host: localhost    Database: system
-- ------------------------------------------------------
-- Server version	4.0.24_Debian-10sarge2-log

--
-- Table structure for table `adresses`
--

CREATE TABLE `adresses` (
  `id` int(9) NOT NULL auto_increment,
  `firstname` varchar(255) NOT NULL default '',
  `lastname` varchar(255) NOT NULL default '',
  `nickname` varchar(255) NOT NULL default '',
  `company` varchar(255) NOT NULL default '',
  `street` varchar(255) NOT NULL default '',
  `streetnumber` int(9) NOT NULL default '0',
  `city` varchar(255) NOT NULL default '',
  `zipcode` varchar(255) NOT NULL default '',
  `phone1` varchar(255) NOT NULL default '',
  `phone2` varchar(255) NOT NULL default '',
  `fax1` varchar(255) NOT NULL default '',
  `mobile1` varchar(255) NOT NULL default '',
  `mobile2` varchar(255) NOT NULL default '',
  `email1` varchar(255) NOT NULL default '',
  `email2` varchar(255) NOT NULL default '',
  `email3` varchar(255) NOT NULL default '',
  `www` varchar(255) NOT NULL default '',
  `messenger` varchar(255) NOT NULL default '',
  `type` enum('contact','billing','other') NOT NULL default 'contact',
  `customer_id` int(16) NOT NULL default '0',
  `created_at` int(16) NOT NULL default '0',
  `updated_at` int(16) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Adressen der Kunden';

--
-- Table structure for table `apache_vhost`
--

CREATE TABLE `apache_vhost` (
  `id` int(14) NOT NULL auto_increment,
  `text` text NOT NULL,
  `is_enabled` enum('yes','no') NOT NULL default 'no',
  `created_at` int(16) NOT NULL default '0',
  `updated_at` int(16) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Zwischengespeicherte Apache Konfiguration';

--
-- Table structure for table `config`
--

CREATE TABLE `config` (
  `id` int(16) NOT NULL auto_increment,
  `property` varchar(255) NOT NULL default '',
  `value` text NOT NULL,
  `created_at` int(16) NOT NULL default '0',
  `updated_at` int(16) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `property` (`property`)
) TYPE=MyISAM;

--
-- Table structure for table `customer`
--

CREATE TABLE `customer` (
  `id` int(9) NOT NULL auto_increment,
  `name` varchar(255) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `notes` text,
  `contract_filename` varchar(255) NOT NULL default '',
  `updated_at` int(16) NOT NULL default '0',
  `created_at` int(16) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Tabelle der Kunden';

--
-- Table structure for table `debmin_queue`
--

CREATE TABLE `debmin_queue` (
  `id` int(14) NOT NULL auto_increment,
  `module` varchar(100) NOT NULL default '',
  `command` varchar(100) NOT NULL default '',
  `param0` varchar(255) NOT NULL default '',
  `param1` varchar(255) NOT NULL default '',
  `param2` varchar(255) NOT NULL default '',
  `param3` varchar(255) NOT NULL default '',
  `done` enum('yes','no') NOT NULL default 'yes',
  `created_at` int(16) NOT NULL default '0',
  `updated_at` int(16) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='debmin Java Cronjob Queue';

--
-- Table structure for table `exim_blacklist`
--

CREATE TABLE `exim_blacklist` (
  `address` varchar(50) NOT NULL default ''
) TYPE=MyISAM;

--
-- Table structure for table `exim_domains`
--

CREATE TABLE `exim_domains` (
  `id` int(9) NOT NULL auto_increment,
  `domain` varchar(255) NOT NULL default '',
  `is_enabled` enum('yes','no') NOT NULL default 'no',
  `customer_id` int(9) NOT NULL default '0',
  `created_at` int(16) NOT NULL default '0',
  `updated_at` int(16) NOT NULL default '0',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `domain` (`domain`)
) TYPE=InnoDB COMMENT='Tabelle aller von exim erkannten Domains';

--
-- Table structure for table `exim_emailtable`
--

CREATE TABLE `exim_emailtable` (
  `id` int(9) NOT NULL auto_increment,
  `local_part` varchar(255) NOT NULL default '',
  `domain` varchar(255) NOT NULL default '',
  `forward` varchar(255) default NULL,
  `cc` varchar(255) default NULL,
  `name` varchar(255) NOT NULL default '',
  `pwclear` varchar(255) NOT NULL default '',
  `pwcrypt` varchar(255) NOT NULL default '',
  `is_away` enum('yes','no') NOT NULL default 'no',
  `away_text` text,
  `spam_check` enum('yes','no') NOT NULL default 'no',
  `spam_purge` enum('yes','no') NOT NULL default 'no',
  `virus_check` enum('yes','no') NOT NULL default 'no',
  `is_enabled` enum('yes','no') NOT NULL default 'yes',
  `customer_id` int(9) NOT NULL default '0',
  `created_at` int(16) NOT NULL default '0',
  `updated_at` int(16) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=InnoDB COMMENT='Alle virtuellen Mail-Accounts';

--
-- Table structure for table `exim_whitelist`
--

CREATE TABLE `exim_whitelist` (
  `address` varchar(50) NOT NULL default ''
) TYPE=MyISAM;

--
-- Table structure for table `groups`
--

CREATE TABLE `groups` (
  `uid` smallint(10) NOT NULL default '0',
  `adm` tinyint(4) NOT NULL default '0',
  `wheel` tinyint(4) NOT NULL default '0',
  `users` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`uid`)
) TYPE=MyISAM;

--
-- Table structure for table `log`
--

CREATE TABLE `log` (
  `id` int(32) NOT NULL auto_increment,
  `host` varchar(255) NOT NULL default '',
  `priority` varchar(9) NOT NULL default '',
  `facility` varchar(255) NOT NULL default '',
  `message` varchar(255) NOT NULL default '',
  `created_at` varchar(16) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM COMMENT='Logfile fr Kundenmen und debmin';

--
-- Table structure for table `proftpd_stats`
--

CREATE TABLE `proftpd_stats` (
  `username` tinytext,
  `filename` text,
  `size` bigint(20) default NULL,
  `host` tinytext,
  `ip` tinytext,
  `aktion` tinytext,
  `dauer` tinytext,
  `zeit_lokal` datetime default NULL,
  `success` char(1) default NULL,
  `ui` bigint(20) NOT NULL auto_increment,
  PRIMARY KEY  (`ui`)
) TYPE=MyISAM;

--
-- Table structure for table `proftpd_user`
--

CREATE TABLE `proftpd_user` (
  `id` int(9) NOT NULL auto_increment,
  `username` varchar(255) NOT NULL default '',
  `password` varchar(255) NOT NULL default '',
  `uid` int(11) NOT NULL default '0',
  `gid` int(11) NOT NULL default '0',
  `homedir` varchar(255) NOT NULL default '',
  `count` int(11) default NULL,
  `shell` varchar(255) default NULL,
  `last_access` int(16) default NULL,
  `is_enabled` enum('yes','no') NOT NULL default 'no',
  `customer_id` int(9) NOT NULL default '0',
  `created_at` int(16) NOT NULL default '0',
  `updated_at` int(16) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=InnoDB COMMENT='Alle virtuellen FTP-Accounts';

--
-- Table structure for table `syslog`
--

CREATE TABLE `syslog` (
  `host` varchar(32) default NULL,
  `facility` varchar(10) default NULL,
  `priority` varchar(10) default NULL,
  `level` varchar(10) default NULL,
  `tag` varchar(10) default NULL,
  `date` date default NULL,
  `time` time default NULL,
  `program` varchar(15) default NULL,
  `msg` text,
  `seq` int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`seq`),
  KEY `host` (`host`),
  KEY `seq` (`seq`),
  KEY `program` (`program`),
  KEY `time` (`time`),
  KEY `date` (`date`),
  KEY `priority` (`priority`),
  KEY `facility` (`facility`)
) TYPE=MyISAM;

--
-- Table structure for table `userpref`
--

CREATE TABLE `userpref` (
  `username` varchar(60) NOT NULL default '',
  `preference` varchar(30) NOT NULL default '',
  `value` varchar(100) NOT NULL default '',
  `prefid` int(11) NOT NULL auto_increment,
  `jaw_uid` varchar(255) NOT NULL default '',
  `adm_uid` int(10) NOT NULL default '0',
  PRIMARY KEY  (`prefid`),
  KEY `username` (`username`)
) TYPE=MyISAM COMMENT='SpamAssassin User Preferences';

