<?php
include_once("../lib/_class.dba.inc.php");
include_once("../config/_conf.dba.inc.php");
include_once("../lib/_static.session.inc.php");
include_once("../lib/_static.misc.inc.php");
include_once("../lib/_class.multipart_mail.inc.php");
include_once("../lib/_class.ispproxy.inc.php");
validate_session();

// Step 0-1: Check input
$domain = $_POST['domain'];

$regexp = "@^([A-za-z0-9]+[.])+[a-zA-Z]+$@i"; // check if a valid hostname was entered
if(!preg_match($regexp, $domain, $treffer)) { // invalid url, return to main-page
  $_SESSION['flash'] = ">>> WARNING: Domain '".$domain."' is invalid! <<<";
  header("Location: ".get_config_value('url_protocol')."://".$_SERVER['HTTP_HOST'].rtrim(dirname($_SERVER['PHP_SELF']), '/\\')."/../welcome.php");
  die();
}

// Step 0: init data, e.g. create passwords
$customer_id = $_SESSION['ID'];
$pwFtpClear = generatePassword();
$mailFrom = get_config_value('admin_mail');
$docRoot = get_config_value('base_dir_www').$domain;

$apache_version = get_config_value('apache_version');
$ipaddress = get_config_value('dns_ipaddress');
$mailserver = get_config_value('dns_mailserver');

// 0 -> local_part, 1 -> pwclear. 2 -> pwcrypt
$i = 0;
$pwclear = generatePassword();
$password = vcrypt($pwclear);
$mailaccounts[$i][0] = $_POST['local_part1'];
$mailaccounts[$i][1] = $pwclear;
$mailaccounts[$i++][2] = $password;

$forward_to = $mailaccounts[0][0]."@".$domain;

$pwclear = generatePassword();
$password = vcrypt($pwclear);
$mailaccounts[$i][0] = $_POST['local_part2'];
$mailaccounts[$i][1] = $pwclear;
$mailaccounts[$i++][2] = $password;
$pwclear = generatePassword();
$password = vcrypt($pwclear);
$mailaccounts[$i][0] = $_POST['local_part3'];
$mailaccounts[$i][1] = $pwclear;
$mailaccounts[$i++][2] = $password;
if(strlen($_POST['local_part4']) > 0) {
  $pwclear = generatePassword();
  $password = vcrypt($pwclear);
  $mailaccounts[$i][0] = $_POST['local_part4'];
  $mailaccounts[$i][1] = $pwclear;
  $mailaccounts[$i++][2] = $password;
}
if(strlen($_POST['local_part5']) > 0) {
  $pwclear = generatePassword();
  $password = vcrypt($pwclear);
  $mailaccounts[$i][0] = $_POST['local_part5'];
  $mailaccounts[$i][1] = $pwclear;
  $mailaccounts[$i++][2] = $password;
}

// Step 1: Create DNS-Entry
$zone = get_domain_from_domain($domain).".";
$rrs[] = $domain.". IN A ".$ipaddress;
$rrs[] = $domain.". IN MX 10 ".$mailserver;
$ispp = new ispproxy();
if($ispp->is_ispproxy_dnszone($zone)) {
	$ispp->dns_add_rr($zone, $rrs);
} else {
	$ispp->dns_create_zone($zone, $rrs);
}

// Step 1: add exim_domain for mail accounts
$query = "INSERT INTO exim_domains (domain,is_enabled,customer_id,created_at,updated_at) VALUES ('".$domain."','yes','".$customer_id."','".time()."','".time()."')";
$dba->query($query);

// Step 2: add mail addresses
// STep 2a: mailboxes
$query = "INSERT INTO exim_emailtable (local_part,domain,forward,cc,name,pwclear,pwcrypt,is_away,away_text,spam_check,spam_purge,virus_check,is_enabled,customer_id,created_at,updated_at) VALUES ('".$mailaccounts[0][0]."','".$domain."','','','','".$mailaccounts[0][1]."','".$mailaccounts[0][2]."','no','','yes','no','no','yes','$customer_id','".time()."','".time()."')";
$dba->query($query);

for($i = 3; $i < sizeof($mailaccounts); $i++) {
  $query = "INSERT INTO exim_emailtable (local_part,domain,forward,cc,name,pwclear,pwcrypt,is_away,away_text,spam_check,spam_purge,virus_check,is_enabled,customer_id,created_at,updated_at) VALUES ('".$mailaccounts[$i][0]."','".$domain."','','','','".$mailaccounts[$i][1]."','".$mailaccounts[$i][2]."','no','','yes','no','no','yes','$customer_id','".time()."','".time()."')";
  $dba->query($query);
}

// Step 2b: Forwarders
for($i = 1; $i < 3; $i++) {
  $query = "INSERT INTO exim_emailtable (local_part,domain,forward,cc,name,pwclear,pwcrypt,is_away,away_text,spam_check,spam_purge,virus_check,is_enabled,customer_id,created_at,updated_at) VALUES ('".$mailaccounts[$i][0]."','".$domain."','".$forward_to."','','','".$mailaccounts[$i][1]."','".$mailaccounts[$i][2]."','no','','yes','no','no','yes','$customer_id','".time()."','".time()."')";
  $dba->query($query);
  //print_r($query);
  //echo("<br>\n");
}

// Step 3: create FTP-Account
$uid = 65534;
$gid = 33;
$count = 0;
$shell = "/bin/false";
$last_access = 0;

$query = "INSERT INTO proftpd_user (username,password,uid,gid,homedir,count,shell,last_access,is_enabled,customer_id,created_at,updated_at) VALUES ('".$domain."','".$pwFtpClear."','".$uid."','".$gid."','".$docRoot."','".$count."','".$shell."','".$last_access."','yes','".$customer_id."','".time()."','".time()."')";
$dba->query($query);

// Step 4: create vhost
$query = "INSERT INTO debmin_queue (module,command,param0,param1,param2,param3,done,created_at,updated_at) VALUES ('apache".$apache_version."','create','".$domain."','".$docRoot."','webmaster@".$domain."','','no','".time()."','".time()."')";
$dba->query($query);

// Step 5: init mail-accounts/enqueue task
for($i = 0; $i < sizeof($mailaccounts); $i++) {
  $address = $mailaccounts[$i][0]."@".$domain;
  $query = "INSERT INTO debmin_queue (module,command,param0,param1,param2,param3,done,created_at,updated_at) VALUES ('mail','init','".$address."','','','','no','".time()."','".time()."')";
  $dba->query($query);
  //print_r($query);
  //echo("<br>\n");
}

// Step 6: Send mail with login information
$body = "Sehr geehrter Anwender,\n";
$body .= "\nanbei finden Sie die Zugangsdaten zu dem eben von Ihnen erstellen Account.\n\n";
$body .= "Bitte beachten Sie, dass es bis zu 15 dauern kann, bis alle Einstellungen wirksam werden.\n\n";
$body .= "Ihre Domain: http://".$domain."/\n";
$body .= "-------------------\n";
$body .= "FTP-Zugang:\n";
$body .= "Server: ftp.".$domain."\n";
$body .= "Login: ".$domain."\n";
$body .= "Passwort: ".$pwFtpClear."\n";
$body .= "-------------------\n";
$body .= "eMail-Konten:\n";
$body .= "Server: mail.".$domain."\n";
$body .= "Unterst�tzte Protokolle: SMTP, POP3, POP3-S, IMAP-S\n\n";
$body .= "Login: ".$mailaccounts[0][0]."@".$domain."\n";
$body .= "Passwort: ".$mailaccounts[0][1]."\n\n";
for($i = 3; $i < sizeof($mailaccounts); $i++) {
  $body .= "Login: ".$mailaccounts[$i][0]."@".$domain."\n";
  $body .= "Passwort: ".$mailaccounts[$i][1]."\n\n";
}
$body .= "Folgende Weiterleitungen wurden automatisch f�r Sie eingerichtet:\n";
$body .= "info@".$domain." wird weitergeleitet nach ".$mailaccounts[0][0]."@".$domain."\n";
$body .= "mail@".$domain." wird weitergeleitet nach ".$mailaccounts[0][0]."@".$domain."\n";
$body .= "-------------------\n\n";
$body .= "Mit freundlichen Gr�ssen\ndebmin\n";
$dest = get_customer_mail($customer_id);
$subject = "[debmin] Zugangsdaten";

$mail = new multipartmail($dest,$src,$subject);
$mail->addmessage($body);
$mail->addbcc($mailFrom); // send all mails also to the sender, just for the records
$mail->sendmail();


// Step 7: Redirect to welcome-page
$_SESSION['flash'] = "Successfully created new Subdomain ".$domain." and sent login information.";

header("Location: ".get_config_value('url_protocol')."://".$_SERVER['HTTP_HOST'].rtrim(dirname($_SERVER['PHP_SELF']), '/\\')."/../welcome.php");

exit();
?>
